PAGE 58,132
;******************************************************************************
TITLE VMPAGES 
;******************************************************************************
;
; COPYRIGHT:
;
;   (C) Copyright Microsoft Corp. 1993.  All rights reserved.
;
;   You have a royalty-free right to use, modify, reproduce and
;   distribute the Sample Files (and/or any modified version) in
;   any way you find useful, provided that you agree that
;   Microsoft has no warranty obligations or liability for any
;   Sample Application Files which are modified.
;
;   Title:      VMPAGES.ASM 
;
;   Version:    3.00
;
;   Date:       22-May-1991 
;
;   Author:     Neil Sandlin
;
;   Description: This VxD demonstrates how to export a VxD service, 
;                _GetVMPgCount, to an application.
;
;
;------------------------------------------------------------------------------
;
;   Change log:
;
;      DATE     REV                 DESCRIPTION
;   ----------- --- -----------------------------------------------------------
;
;==============================================================================

        .386p

;******************************************************************************
;                             I N C L U D E S
;******************************************************************************

        .XLIST
        INCLUDE VMM.Inc
        INCLUDE Debug.Inc
        INCLUDE VMPAGES.Inc
        .LIST


;******************************************************************************
;                V I R T U A L   D E V I C E   D E C L A R A T I O N
;******************************************************************************

Declare_Virtual_Device VMPAGES, 3, 0, VMPAGES_Control, VMPAGES_Dev_ID,, \
                                    VMPAGES_API_PROC , VMPAGES_API_Proc



VxD_ICODE_SEG

;******************************************************************************
;
;   VXD_Device_Init
;
;   DESCRIPTION:
;       This is a shell for a routine that is called at system BOOT.
;       Typically, a VxD would do its initialization in this routine.
;
;   ENTRY:
;       EBX = System VM handle
;
;   EXIT:
;       Carry clear to indicate load success
;       Carry set to abort loading this VxD
;
;   USES:
;       flags
;
;==============================================================================

BeginProc VXD_Device_Init

IFDEF DEBUG
        Trace_Out "VMPAGES installed"
ENDIF
        clc                             ;no error - load VxD 
        ret

EndProc VXD_Device_Init

VxD_ICODE_ENDS


VxD_LOCKED_CODE_SEG

;******************************************************************************
;
;   VMPAGES_Control
;
;   DESCRIPTION:
;
;       This is a call-back routine to handle the messages that are sent
;       to VxD's to control system operation.  However, in this example,
;       there's no code because we don't want any call-back calls.
;
;
;==============================================================================

BeginProc VMPAGES_Control

        Control_Dispatch Device_Init, VXD_Device_Init
        clc
        ret

EndProc VMPAGES_Control


VxD_LOCKED_CODE_ENDS


VxD_CODE_SEG

BeginDoc
;******************************************************************************
;
;   VMPAGES_API_Proc
;
;   DESCRIPTION:
;
;       This is the exported API procedure that is callable from VM's. 
;       An application needs only to use INT 2Fh, AX=1684h, BX=device ID
;       and a call back address is returned. Then, when the
;       address is called, eventually it ends up here. 
;
;
;==============================================================================
EndDoc

BeginProc VMPAGES_API_Proc

        and     [ebp.Client_Flags], NOT CF_Mask ; clear VM's carry flag

        Client_Ptr_Flat edi, ES, DI             ; point to buffer

        VMMCall _GetVMPgCount, <ebx, 0>
        mov     [edi], eax
        mov     [edi+4], edx

        ret

EndProc VMPAGES_API_Proc

VxD_CODE_ENDS

        END
